"""
Cuchulufm is a series of wrappers for bottle, mako and others and construct a simple headless cms.

Copyright (C) 2023 Antonio de la Rosa Caballero

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.
"""

from cuchulu.libraries.db.corefields import PhangoField
from cuchulu.libraries import datetime
try:
    from cuchulu.libraries.db.extraforms.dateform import DateForm
except:
    class DateForm:
        pass

class DateTimeField(PhangoField):
    """Field for use and save dates in MySQL date format"""
    
    def __init__(self, name, size=255, required=False):
        
        super().__init__(name, size, required)
        
        self.name_form=DateForm
        
        self.utc=False
        
        self.error_default='Error: Date format invalid'        
        
        self.type_sql='datetime'
        
        self.jformat='date-time'
        self.jtype='string'
        self.jexample='2022-12-01 12:24:11'
    
    def check(self, value):
        
        if self.utc:
        
            value=datetime.local_to_gmt(value)
        
        elif not datetime.obtain_timestamp(value):
            
            self.error=True
            self.txt_error=self.error_default
            
            return '0000-00-00 00:00:00'
        
        if value==False:
            
            self.error=True
            self.txt_error=self.error_default
            return '0000-00-00 00:00:00'
        else:
            
            """
            format_date_txt="YYYY/MM/DD"

            format_time_txt="HH:mm:ss"
            """
            
            value=datetime.format_local_strtime('YYYY-MM-DD HH:mm:ss', value)
        
        return value
    
    def show_formatted(self, value):
        
        # Convert to paramecio value
        
        value=str(value)
        value=value.replace('-', '').replace(':', '').replace(' ', '')
        
        return datetime.format_date(value)

    def get_type_sql(self):
        
        """Method for return the sql code for this type

        """

        return 'DATETIME NOT NULL'
